If @Compiled Then
	MsgBox(0, "", "You should not use TeenyScript compiled, it wont work that way")
	Exit
EndIf
#include "_Dependencies_\_Header_.au3"
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <string.au3>
#include <FileConstants.au3>
#include <File.au3>

#Region Enums
Global Enum $_SCOPE_GLOBAL, $_SCOPE_LOCAL
#EndRegion Enums

#Region settings and misc
Global Const $ts_fileVer = "Beta 5"
Global Const $ts_TargetExt = ".au3" ; Target file extension
Global Const $fnc_BaseName = rString(3)
Global Const $cls_varBaseName = rString(3)
Global Const $cls_MethodRefName = rString(4)
Global Const $this_varBaseName = "this" ; if u dont want to use $this as a reserved variable, you can change this to whatever you want, WARNING this will affect how scripts work!
#EndRegion settings and misc

#Region Regex FileWatcher
Global Const $re_curFileDetection = "( - SciTE.*)" ; To extract the current file path open in scite window
#EndRegion Regex FileWatcher

#Region Regex
; These should not not contain any matching-groups
Global Const $re_AcceptedVarName = "[a-z0-9_]+" ; What chars are accepted as a accepted variablename.
Global Const $re_AcceptedNamespace = "[a-z\/_]+" ; Accepted namespaces: str/_undrescore
Global Const $re_AcceptedNamespaceAlias = "[a-z]+"
; Yeah this is is exactly what it says it is
;;
;Namespaces can only be a-z and _  create an VAR for that
; Variables can only be a-z-0-9_ create a var for dat regex Thoooo TOO
;;
Global Const $re_NestedFunctions = "(?mi)^\h*(?:(\$(" & $re_AcceptedVarName & ")\h*=|)|)\h*func\h*\((.+|)\)\h*\n((?:\h*+(?!(?:(?:\$" & $re_AcceptedVarName & "\h*=\h*|)func\h*\(.+|\)|endfunc(?:[^\n]*))\h*$)[^\n]*\n|(?R)\n)*)\h*endfunc\h*([^\n]*)$"
Global Const $re_ClassDetection = "(?i)\h*class\h*(?:[,]+|)\h*(.*)"
Global Const $re_ExtensionDetection = "(?i)\h*extension\h*(?:[,]+|)\h*(.*)"
Global Const $re_ClassExtensionExtender = "(?i)\$(" & $re_AcceptedVarName & ")\(\h*(?:\$" & $this_varBaseName & "\h*(.*))\)" ;
Global Const $re_ClassProperties = "(?i)(?:@|)(private|public|readonly)\h*\$" & $this_varBaseName & "\.([a-z_]+[0-9]*)\h*=\h*([^\n]+)"
Global Const $re_NamespaceDetection = "(?i)^\h*\@Namespace\h+(" & $re_AcceptedNamespace & ")" ; only accepts a-z
Global Const $re_NamespaceMacro = "(?i)\@Namespace" ; this will be used to retrive the namespace name as a @Macro
Global Const $re_NamespaceUseInDetection = "(?i)\@Use\h+(" & $re_AcceptedNamespace & ")\h+(?:In|At|On|As)\h+(" & $re_AcceptedNamespaceAlias & ")" ; will detect @Use x/x In At On As x
Global Const $re_MethodNameMacro = "(?i)(\@MethodName)"
Global Const $re_MethodParamsMacro = "(?i)(\@MethodParams)"
Global Const $re_Main = "(?si)#MAIN(.*)"
Global Const $re_fileExt = "(?i)(\.ts\.au3)$" ; WHat file to look for
Global Const $re_tsInclude = '(?i)\#include\h*(?:\<|\")([a-z0-9_ \\\/]+((?:[\*]{0,2}|)\.ts|\.au3))\h*(?:\>|\")' ; #include detection

; Reserved things i wanna do
Global Const $re_JSONTEXT = "\{([^{}]*(?:[^{}]*|(?R)))\}\n*" ; This will match just like json
Global Const $re_MagicParam = "(?:,|)\h*\$\((" & $re_AcceptedVarName & ")\)" ; A magic param will move the content into the code and must be a sring, $e = func(class, $(namespace), $b) and cannot be applied to a class or extension method, but global classes are fine, its designed for the developer
#EndRegion Regex

#Region Resources
Global $errMsg = ""
Global $ScITEhwnd = WinGetHandle("[CLASS:SciTEWindow]")
Global $AutoitDir = StringRegExpReplace(@AutoItExe, "(.*\\)(.*)", "$1")
Global $AoIncluded = False
Global $rBuffer = "" ; Where we store all da content for da current fila
Global $aIncludedFiles[1] = [0]
Global $aNameSpaces[1] = [0]
#EndRegion Resources


TS_HotkeyMode("enable")
AdlibRegister("__Connection", 2500)

MsgBox(0, "", "Use F5 to 'Run script' " & @CRLF & "Use F7 to 'Build Script to .au3'")
ControlSend($ScITEhwnd, "", "Scintilla2", "+{F5}")
TrayTip("TeenyScript " & $ts_fileVer, "Ready! " & @CRLF & "Press F10 in scite to Exit", 30, 1)

While 1

WEnd

;IF we close scite, we close TeenyScript
Func __Connection()
	If Not IsHWnd($ScITEhwnd) Then
		MsgBox(0, "", "TeenyScript closed because Scite was closed")
		AdlibUnRegister("__Connection")
		Exit
	EndIf
EndFunc   ;==>__Connection
Func __EXIT()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		TS_HotkeyMode("disable")
		Send("{F10}")
		TS_HotkeyMode("enable")
		Return False
	EndIf
	ConsoleWrite(" # # # # TScript Ended by user... # # # # " & @CRLF)
	Exit
EndFunc   ;==>__EXIT
Func _BUILDTS()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		TS_HotkeyMode("disable")
		Send("{F7}")
		TS_HotkeyMode("enable")
		Return False
	EndIf

	Local $finalFile = _COMILETS(False) ; wont delete file and wont run
	If Not FileExists($finalFile) Then Return False
	MsgBox(0, "", "File has been compiled @ '" & $finalFile & "'")
EndFunc   ;==>_BUILDTS

Func _RUNTS()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		TS_HotkeyMode("disable")
		Send("{F5}")
		TS_HotkeyMode("enable")
		Return False
	EndIf

	Return _COMILETS(True)
EndFunc   ;==>_RUNTS

Func _COMILETS($delete)
	Local $curFile = _getSciteOpenFile()
	Local $isTS = StringRegExp($curFile, $re_fileExt)
	Local $compiledFile = Null

	;Reset global resources
	$rBuffer = ""
	$AoIncluded = False
	_array_empty($aIncludedFiles)
	_array_empty($aNameSpaces)

	;If this is a valid file we will parse and run the created file in the same file (huh?)
	If $isTS Then
		$compiledFile = _ParseFile($curFile)
		If @error Then
			Local $errMsgHash = rString(StringLen($errMsg), "#")
			ConsoleWrite(@CRLF & @TAB & $errMsgHash & @CRLF & "!" & @TAB & "An Error occured while parsing: " & $curFile & @CRLF & ">" & @TAB & $errMsg & @CRLF & @TAB & $errMsgHash & @CRLF)
			Return False
		EndIf
		; Run the compiled file
		ConsoleWrite(" # # # # TScript running: " & $curFile & " # # # # " & @CRLF)
		Local $timer = TimerInit()
		If $delete Then RunWait(@AutoItExe & ' "' & $compiledFile & '"', "", Default, $STDIN_CHILD)
		; Delete after RUN

		ConsoleWrite(" # # # # End: ~" & TimerDiff($timer) & " ms # # # # " & @CRLF)
		Sleep(150)
		If $delete Then FileDelete($compiledFile)
		Return $compiledFile
	Else ; Run file as usual without autoit Wrapper
		MsgBox(0, "", "Not a valid .ts.au3 file" & @CRLF & @CRLF & "Use F10 to exit TeenyScript")
	EndIf
	;Reset error msg
	$errMsg = ""
EndFunc   ;==>_COMILETS


; will convert ts to *.au3
Func _ParseFile($sFileName, $rFhandle = True)


	If Not FileExists($sFileName) Then
		$errMsg = StringFormat("The file '%s' does not exist", $sFileName)
		Return SetError(1, 0, 0)
	EndIf

	If fileIncluded($sFileName) Then
		$errMsg = StringFormat("The file '%s' is already included", $sFileName)
		Return SetError(2, 0, 0)
	EndIf

	; Convert current path + Filename to hex, in that way we can ensure colission is not an option for functions
	Local $x_gFile = _StringToHex($sFileName)
	; Set resources for file
	Local $aClassMembers[1] = [0] ; Alla "class members" for this file, reset at new file 2 save forestfires
	Local $x_cFuncID = 0
	Local $currentNameSpace = "", $rawNameSpace = ""


	Local $sTargetFilename = StringRegExpReplace($sFileName, $re_fileExt, $ts_TargetExt)
	; Check if we need to include this file

	; Prepare file content
	Local $sBuffer = StringReplace(FileRead($sFileName), @CRLF, @LF)

	; Check if we going to include some files both ts. and .au3 files.
	Local $aTSInclude = StringRegExp($sBuffer, $re_tsInclude, 3)
	If IsArray($aTSInclude) Then
		Local $aTSIncludeLen = UBound($aTSInclude) - 1
		For $i = 0 To $aTSIncludeLen Step +2

			Local $curFileExt = $aTSInclude[$i + 1]
			Local $curFilePath = StringReplace(StringRegExpReplace($sFileName, "(.*(?:\\|\/))(.*)", "$1"), "/", "\")
			Local $tsIncludeDir = StringReplace(StringRegExpReplace($aTSInclude[$i], "(.*(?:\\|\/))(.*)", "$1"), "/", "\")
			Local $tsIncludeFullPath = $curFilePath & $tsIncludeDir

			Switch $curFileExt
				Case '.au3' ; Just add to buffer
					$rBuffer &= "#Include <" & $aTSInclude[$i] & ">" & @CRLF
					ContinueLoop
				Case '.ts' ; Include as usual
					_ParseFile($curFilePath & StringFormat("%s.au3", $aTSInclude[$i]), False) ;Parse next file but dont save the file as a new file
				Case Else
					If $curFileExt == '*.ts' Or $curFileExt == '**.ts' Then
						Local $_FileListToArrayRec = _FileListToArrayRec($tsIncludeFullPath, "*.ts.au3||BackUp", $FLTAR_FILES, ($curFileExt == '*.ts' ? $FLTAR_NORECUR : $FLTAR_RECUR), $FLTAR_NOSORT, $FLTAR_FULLPATH)
						If @error Then
							Switch @error
								Case 1
									$errMsg = StringFormat("The folder '%s' is empty or does not exist", $tsIncludeFullPath)
									Return SetError(3, 0, 0)
								Case 9
									$errMsg = StringFormat("The folder '%s' does not contain any files or folders", $tsIncludeFullPath)
									Return SetError(4, 0, 0)
							EndSwitch
						Else
							For $j = 1 To $_FileListToArrayRec[0]
								_ParseFile($_FileListToArrayRec[$j], False)
								If @error Then ExitLoop
							Next
						EndIf
					EndIf
			EndSwitch

			If @error Then Return SetError(@error, 0, 0)
		Next
	EndIf

	Local $oFuncs = Null ; Destroy prev object
	$oFuncs = _AutoitObject_LinkedList()
	_ParseFuncRec($sBuffer, Null, $oFuncs)

	;This we are doing to stack everything in the file we are running
	If $rFhandle Then
		Local $fHandle = FileOpen($sTargetFilename, 2)
	EndIf

	;Just include this once.
	If Not $AoIncluded Then
		$rBuffer &= '#include "_Header_.au3"' & @CRLF
		$AoIncluded = True
	EndIf

	;Determine if current file has a namespace (Only affects GLOBAL SCOPE)
	; IMPORTANT NAMESPACE ONLY TAKE FROM FILE BUFFER, NOT ON DA Global Return Buffer
	Local $nameSpaceInfo = StringRegExp($sBuffer, $re_NamespaceDetection, 3)
	Local $hasNameSpace = IsArray($nameSpaceInfo)

	If $hasNameSpace Then
		;Store the raw namespace globally, we are going to use it to match internally in functions
		$rawNameSpace = $nameSpaceInfo[0]
		$currentNameSpace = StringReplace($rawNameSpace, "/", "_") & "_" ; Add an ending _        "_"
		;Remove the var from buffer
		$sBuffer = StringRegExpReplace($sBuffer, $re_NamespaceDetection, "")
		; Add namespaces for later
		Local $NmSpaceData = [$rawNameSpace & "/", $currentNameSpace] ; add a / to this because we ad a _ to the current namespace
		_Array_Push($aNameSpaces, $NmSpaceData)
	EndIf

	Local $aNamespaceAliasUsage[1] = [0]
	;Local $aLocalMethodsClean[1] = [0]

	For $item In $oFuncs
		;Get parameters from extension or class info if needed
		Local $paramClassInfo = StringRegExp($item.params, $re_ClassDetection, 3)
		Local $paramExtensionInfo = StringRegExp($item.params, $re_ExtensionDetection, 3)
		;Determine if class or extension
		Local $isClass = IsArray($paramClassInfo)
		Local $isExtension = IsArray($paramExtensionInfo)
		Local $isExtOrClass = $isClass + $isExtension

		; Generate function name based on file path + function name ID (The actual Autoit Function name)
		Local $cFunkName = $fnc_BaseName & $x_gFile & $x_cFuncID

		; Adjust params for class and extension (They can never collide xD)
		If $isClass Or $isExtension Then
			;If we are gooing to use $this or the unkown $variable
			Local $finalParamsVar = ""

			;If class
			If $isClass Then
				$item.params = $paramClassInfo[0]
				$finalParamsTemplate = $this_varBaseName
			EndIf

			;If extension
			If $isExtension Then
				$item.params = $paramExtensionInfo[0]
				$finalParamsTemplate = $cls_varBaseName
			EndIf

			;Set params based on how they look only on SUB functions @ Classes, but Extensions can have this shit whenever
			If ($item.scope == $_SCOPE_LOCAL And $isClass Or $isExtension) Then
				If isEmpty($item.params) Then
					$item.params = "$" & $finalParamsTemplate
				Else
					$item.params = StringFormat("$%s, %s", $finalParamsTemplate, $item.params)
				EndIf
			EndIf

			; Fix properties for classes and extensions
			Local $propertyTmplt = StringFormat("$%s.AddProperty('$2',$ELSCOPE_$1, $3)", $cls_varBaseName)
			$item.content = StringRegExpReplace($item.content, $re_ClassProperties, $propertyTmplt)
		EndIf


		; Check if we gonna create an "class object with AutoitObject". This only applies to classes
		If $isClass Then
			; Check for class extensions and replace them, this is exclusive to classes
			$item.content = StringRegExpReplace($item.content, $re_ClassExtensionExtender, "$$1($" & $cls_varBaseName & "$2)")

			; Only add $this if subclass, not for global
			Local $assignParentVar = $item.scope == $_SCOPE_LOCAL ? @TAB & StringFormat("$%s.AddProperty('__parent__',$ELSCOPE_READONLY, $%s)", $cls_varBaseName, $this_varBaseName) & @CRLF : ""

			; Create a method Array for Class, this will display all methods to the class via a READONLY prop, this is mostly for debugging
			Local $aClassMethodProp = StringRegExp($item.content, $re_NestedFunctions, 4)
			Local $aClassMethodProp_len = UBound($aClassMethodProp)
			Local $sAClassMethods = '[' & $aClassMethodProp_len ; Build an array
			For $j = 0 To $aClassMethodProp_len - 1
				Local $c = $aClassMethodProp[$j] ; Current method for class
				$sAClassMethods &= StringFormat(', "%s(%s)"', $c[2], StringReplace($c[3], '"', "'"))
			Next
			$sAClassMethods &= "]"


			;Add the AutoitObject class and the __parent__, __classname__ and __namespace__ variable
			$item.content = @TAB & StringFormat("Local $%s = _AutoItObject_Class()", $cls_varBaseName) & @CRLF & _
					@TAB & StringFormat("Local $%s = %s", $cls_MethodRefName, $sAClassMethods) & @CRLF & _
					@TAB & StringFormat("$%s.AddProperty('__Methods__', $ELSCOPE_READONLY, $%s)", $cls_varBaseName, $cls_MethodRefName) & @CRLF & _ ;An array to all the methods of this class (Mostly created for developers
					@TAB & StringFormat("$%s.AddProperty('__cName__', $ELSCOPE_READONLY, '%s')", $cls_varBaseName, $item.varNameClean) & @CRLF & _ ;Will add this name clean
					@TAB & StringFormat("$%s.AddProperty('__cParams__', $ELSCOPE_READONLY, '%s')", $cls_varBaseName, StringReplace($item.params, "'", '"')) & @CRLF & _ ;Will add the params used in this class
					@TAB & StringFormat("$%s.AddProperty('__Namespace__', $ELSCOPE_READONLY, '%s')", $cls_varBaseName, $rawNameSpace) & @CRLF & _ ;Will add this namespace as STRING
					$assignParentVar & _
					$item.content & @CRLF & _
					@TAB & StringFormat("Return $%s.Object", $cls_varBaseName)
		EndIf

		;Assign proper function names for non class (It always going to be the current function +1), we store all the replacements so we can fix the parameters...
		; This method prevents nested classes to be encapsulated by other classes ( OR DOES IT, CAN THIS UGLY REGEX TRICK DO THE SHIZZ FOR ME?
		Local $y = $x_cFuncID + 1, $subFnc, $extended = 0
		Do
			Local $cSubFnkName = $fnc_BaseName & $x_gFile & $y
			If $isClass Or $isExtension Then
				$subFnc = '$' & $cls_varBaseName & '.AddMethod("$2", "%s")'
				_Array_Push($aClassMembers, $cSubFnkName)
			Else
				$subFnc = "$1 %s$5"
			EndIf

			;Not in use yet. Just testing some stuff!
			;
			;Local $mby_Bby = StringRegExp($item.content, $re_NestedFunctions, 4)
			;If IsArray($mby_Bby) And $isClass Then
			;Get FIRST HIT
			;	Local $mby_Bby_first = $mby_Bby[0]
			;	_Array_Push($aLocalMethodsClean, $mby_Bby_first[2]); VarNameClean
			;	_Array_Push($aLocalMethodsClean, $mby_Bby_first[3]); Params
			;EndIf
			;;; after do while _ArrayDisplay($aLocalMethodsClean)

			$item.content = StringRegExpReplace($item.content, $re_NestedFunctions, @TAB & StringFormat($subFnc, $cSubFnkName), 1)
			$extended = @extended
			$y += 1
		Until $extended == 0


		; Last classmember is BOGUS, DO loop replaces 1 extra time for shits and kicks apperently
		If $isClass Or $isExtension Then
			If $aClassMembers[0] > 0 Then
				_Array_Remove($aClassMembers, $aClassMembers[0])
			EndIf
		EndIf

		; Check if this is file is a class member (And not self)
		Local $item_params_clean = $item.params
		If memberOfClass($cFunkName, $aClassMembers) And Not $isClass And Not $isExtension Then
			If isEmpty($item.params) Then
				$item.params = "$" & $this_varBaseName
			Else
				$item.params = StringFormat("$%s, %s", $this_varBaseName, $item.params)
			EndIf
		EndIf

		; Look for @use x AS y in GLOBAL class scope, they will be use throughout the whole file and replace in each function buffer iteration
		Local $aLocalNamespaceUsage = Null
		If $item.scope == $_SCOPE_GLOBAL Then
			$aLocalNamespaceUsage = StringRegExp($item.content, $re_NamespaceUseInDetection, 3)
		EndIf

		If IsArray($aLocalNamespaceUsage) Then
			$item.content = StringRegExpReplace($item.content, $re_NamespaceUseInDetection, "") ; Remove it and keep the store array in $aLocalNamespaceUsage
			; Reset previous $aNamespaceAliasUsage usage array for replacement (This is so we wont replace next global function \ class with previous @Use tags)
			_Array_Empty($aNamespaceAliasUsage)
			For $p = 0 To UBound($aLocalNamespaceUsage) - 1
				_Array_Push($aNamespaceAliasUsage, $aLocalNamespaceUsage[$p])
			Next
		EndIf

		;All macros are handled before we generate a function @Namespace, @MethodName, @MethodParams
		$item.content = StringRegExpReplace($item.content, $re_NamespaceMacro, '"' & $rawNameSpace & '"')
		$item.content = StringRegExpReplace($item.content, $re_MethodNameMacro, '"' & $item.varNameClean & '"')
		$item.content = StringRegExpReplace($item.content, $re_MethodParamsMacro, '"' & StringReplace($item_params_clean, '"', "'") & '"')

		; Finalize the function
		Local $sFinishedFunc = StringFormat("Func %s(%s)", $cFunkName, $item.params) & @CRLF & _
				$item.content & @CRLF & _
				"EndFunc" & @CRLF & _
				($item.scope == $_SCOPE_GLOBAL ? StringFormat("Global Const $%s%s = %s%s", $currentNameSpace, $item.varNameClean, $cFunkName, $item.endFuncStuff) & @CRLF : "")

		;Append finished function to buffer
		$rBuffer &= $sFinishedFunc

		;Increment for each function
		$x_cFuncID += 1

		; End of Function parse after-treatment
		; End of Function parse after-treatment
		; End of Function parse after-treatment

		;Check if we need to replace Aliases previously created with @Use x In y
		If $aNamespaceAliasUsage[0] > 0 Then
			For $t = 1 To $aNamespaceAliasUsage[0] Step +2
				; We do this again because its for internal only, and should not be replaced global, then colission may occur.
				Local $lookFor = "(?i)" & escapeForwardSlash($aNamespaceAliasUsage[$t + 1] & "/\$") ; because we want to find the usage of the locally assigned namespace
				Local $replaceWith = "$" & StringReplace($aNamespaceAliasUsage[$t], "/", "_") & "_" ; add a $ and a finiser _
				; Replace
				$rBuffer = StringRegExpReplace($rBuffer, $lookFor, $replaceWith)
			Next
		EndIf

	Next
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF

	If $rFhandle Then

		;Add the raw to the buffer data (if any)
		Local $rawData = StringRegExp($sBuffer, $re_Main, 3)

		If IsArray($rawData) Then
			$rBuffer = $rBuffer & @CRLF & $rawData[0]
		EndIf

		;Looks for single namespaces to replace because we are at END OF FILE
		Local $_CurNamespace, $lookFor, $replaceWith
		For $w = 0 To $aNameSpaces[0]
			$_CurNamespace = $aNameSpaces[$w]
			If IsArray($_CurNamespace) Then
				$lookFor = $_CurNamespace[0]
				$replaceWith = $_CurNamespace[1]
				$rBuffer = StringReplace($rBuffer, $lookFor & "$", "$" & $replaceWith) ; remove the bogus $ at the end, and add a real $at the beginning
			EndIf
		Next

		FileWriteLine($fHandle, "#Region ~~~")
		FileWriteLine($fHandle, StringRegExpReplace($rBuffer, "\R+", @CRLF))
		FileWriteLine($fHandle, "#EndRegion ~~~")
		FileWriteLine($fHandle, $rawData)

		FileClose($fHandle)
	EndIf

	;Mark this file as included
	_Array_Push($aIncludedFiles, $sFileName)
	Return $sTargetFilename
EndFunc   ;==>_ParseFile

Func _ParseFuncRec($sBuffer, $inRecur, $oFuncs)

	Local $m = StringRegExp($sBuffer, $re_NestedFunctions, 4)
	If @error Then Return SetError(1, 0, 0) ; No more matches

	Local $m_len = UBound($m) - 1
	Local $scope = $inRecur ? $_SCOPE_LOCAL : $_SCOPE_GLOBAL

	For $i = 0 To $m_len
		Local $oFunc = _CObject($m[$i], $scope)

		$oFuncs.add($oFunc)
		_ParseFuncRec($oFunc.content, True, $oFuncs)
	Next
EndFunc   ;==>_ParseFuncRec

Func _CObject($m, $scope)
	Local $oRet = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRet, "varName", $ELSCOPE_PUBLIC, $m[1]) ; contains  $x =
	_AutoItObject_AddProperty($oRet, "varNameClean", $ELSCOPE_PUBLIC, $m[2]) ; Only contains the name x
	_AutoItObject_AddProperty($oRet, "params", $ELSCOPE_PUBLIC, $m[3])
	_AutoItObject_AddProperty($oRet, "content", $ELSCOPE_PUBLIC, $m[4])
	_AutoItObject_AddProperty($oRet, "endFuncStuff", $ELSCOPE_PUBLIC, $m[5]) ; Mby not needed herE?
	_AutoItObject_AddProperty($oRet, "scope", $ELSCOPE_PUBLIC, $scope)
	_AutoItObject_AddProperty($oRet, "memberOfClass", $ELSCOPE_PUBLIC, False) ; Noneeed
	Return $oRet
EndFunc   ;==>_CObject

; Check if we are a member of a class
Func memberOfClass($fncName, ByRef $aClassMembers)
	For $i = 1 To $aClassMembers[0]
		If $aClassMembers[$i] == $fncName Then Return True
	Next
	Return False
EndFunc   ;==>memberOfClass

;Check if is already included. generate a warning
Func fileIncluded($sFileName)
	For $i = 1 To $aIncludedFiles[0]
		If $aIncludedFiles[$i] == $sFileName Then Return True
	Next
	Return False
EndFunc   ;==>fileIncluded

Func _getSciteOpenFile()
	Return StringRegExpReplace(WinGetTitle($ScITEhwnd), $re_curFileDetection, "")
EndFunc   ;==>_getSciteOpenFile

Func _sciteTidyUp(); Will use the native Tidy up but fix the namespacing accordingly
	Local $sOpenFile = _getSciteOpenFile()
	Local $TidyUpExe = $AutoitDir & "\SciTE\Tidy\Tidy.exe "
	If Not FileExists($TidyUpExe) Then
		Return MsgBox(0, "", "Unable to find Tidy.exe" & @CRLF & @CRLF & $TidyUpExe)
	EndIf
	If Not FileExists($sOpenFile) Then
		Return MsgBox(0, "", "Unable to find source, you need to save your work before you can tidy-up" & @CRLF & @CRLF & $sOpenFile)
	EndIf

	TS_HotkeyMode("disable"); Preventing forest fires again
	RunWait(StringFormat('%s "%s"', $TidyUpExe, $sOpenFile), "", Default, $STDIN_CHILD)
	TS_HotkeyMode("enable")
EndFunc

Func TS_HotkeyMode($mode = "enable")
	Switch $mode
		Case "enable"
			HotKeySet("^t", "_sciteTidyUp")
			HotKeySet("{F5}", "_RUNTS")
			HotKeySet("{F7}", "_BUILDTS")
			HotKeySet("{F10}", "__EXIT")
		Case "disable"
			HotKeySet("^t")
			HotKeySet("{F5}")
			HotKeySet("{F7}")
			HotKeySet("{F10}")
	EndSwitch
EndFunc

Func rString($len, $xDD = False)
	Local $ret = ""
	For $i = 1 To $len
		If $xDD == False Then
			$ret &= "_" & Chr(Random(65, 90, 1))
		Else
			$ret &= $xDD
		EndIf
	Next
	Return $ret
EndFunc   ;==>rString

Func isEmpty($str)
	Return StringRegExp($str, "^\s*$")
EndFunc   ;==>isEmpty

Func escapeForwardSlash($str)
	Return StringReplace($str, "/", "\/")
EndFunc   ;==>escapeForwardSlash
