#include "_Dependencies_\_Header_.au3"
#include <ButtonConstants.au3>
#include <GUIConstantsEx.au3>
#include <WindowsConstants.au3>
#include <string.au3>

#Region Enums
Global Enum $_SCOPE_GLOBAL, $_SCOPE_LOCAL
#EndRegion Enums

#Region settings and misc
Global Const $ts_fileVer = "Beta 4"
Global Const $ts_FileExt = "\.ts\.au3" ; Source file extension (What will be converted when F5 is hit)
Global Const $ts_TargetExt = ".au3" ; Target file extension
Global Const $ts_IncludeExt = "\.ts" ; identifier for .ts scripts in #include
Global Const $fnc_BaseName = rString(3)
Global Const $cls_varBaseName = rString(3)
Global Const $this_varBaseName = "this" ; if u dont want to use $this as a reserved variable, you can change this to whatever you want, WARNING this will affect how scripts work!
#EndRegion settings and misc

#Region Regex FileWatcher
Global Const $re_curFileDetection = "( - SciTE.*)" ; To extract the current file path open in scite window
#EndRegion Regex FileWatcher

#Region Regex converter
; Yeah this is is exactly what it says it is
Global Const $re_NestedFunctions = "(?mi)^\h*(?:(\$([a-z0-9_]+)\h*=|)|)\h*func\h*\((.+|)\)\h*\n((?:\h*+(?!(?:(?:\$[a-z0-9_]+\h*=\h*|)func\h*\(.+|\)|endfunc(?:[^\n]*))\h*$)[^\n]*\n|(?R)\n)*)\h*endfunc\h*([^\n]*)$"
Global Const $re_EndfuncComments = "(?mi)EndFunc\h*([^\n]+)"
Global Const $re_ClassDetection = "(?i)\h*class\h*(?:[,]+|)\h*(.*)"
Global Const $re_ClassExtensionDetection = "(?i)\h*extension\h*(?:[,]+|)\h*(.*)"
Global Const $re_ClassExtensionExtender = "(?i)\$([a-z0-9_]+)\(\h*(?:\$" & $this_varBaseName & "\h*\h*(.*))\)";
Global Const $re_ClassProperties = "(?i)(?:@|)(private|public|readonly)\h*\$" & $this_varBaseName & "\.([a-z_]+[0-9]*)\h*=\h*([^\n]+)"
Global Const $re_ExtensionDotConvert = "(?i)\$" & $this_varBaseName & "\h*\."
Global Const $re_NamespaceDetection = "(?i)^\h*\@Namespace\h+([a-z\/_]+)" ; only accepts a-z
Global Const $re_NamespaceMacro = "(?i)\@Namespace"; this will be used to retrive the namespace name as a @Macro
Global Const $re_NamespaceUseInDetection = "(?i)\@Use\h+([a-z\/_]+)\h+(?:In|At|On|As)\h+([a-z]+)" ; will detect @Use x/x In At On As x
Global Const $re_MethodNameMacro = "(?i)(\@MethodName)"
Global Const $re_MethodParamsMacro = "(?i)(\@MethodParams)"
Global Const $re_Main = "(?si)#MAIN(.*)"
Global Const $re_fileExt = "(?i)(" & $ts_FileExt & ")$" ; WHat file to look for
Global Const $re_tsInclude = '(?i)\#include\h*(?:\<|\")([a-z0-9_ \\]+(\.ts|\.au3))\h*(?:\>|\")'
#EndRegion Regex converter

#Region Resources
Global $ScITEhwnd = WinGetHandle("[CLASS:SciTEWindow]")
Global $AoIncluded = False
Global $rBuffer = "" ; Where we store all da content for da current fila
Global $aIncludedFiles[1] = [0]
Global $aNameSpaces[1] = [0]
#EndRegion Resources


HotKeySet("{F5}", "_RUNTS")
HotKeySet("{F7}", "_BUILDTS")
HotKeySet("{F10}", "__EXIT")

MsgBox(0, "", "Use F5 to 'Run script' " & @CRLF & "Use F7 to 'Build Script to .au3'")
TrayTip("TeenyScript "&$ts_fileVer, "Ready! "&@CRLF&"Press F10 in scite to Exit", 30, 1)

While 1

wend
Func __EXIT()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		HotKeySet("{F10}")
		Send("{F10}")
		HotKeySet("{F10}", "__EXIT")
		Return False
	EndIf
	ConsoleWrite(" # # # # TScript Ended by user... # # # # " & @CRLF)
	Exit
EndFunc
Func _BUILDTS()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		HotKeySet("{F7}")
		Send("{F7}")
		HotKeySet("{F7}", "_BUILDTS")
		Return False
	EndIf

	Local $finalFile = _COMILETS(False) ; wont delete file and wont run
	MsgBox(0, 0, "Compiled to regular .au3 @ '" & $finalFile & "'")
EndFunc   ;==>_BUILDTS

Func _RUNTS()
	If WinGetHandle("[ACTIVE]") <> $ScITEhwnd Then
		HotKeySet("{F5}")
		Send("{F5}")
		HotKeySet("{F5}", "_RUNTS")
		Return False
	EndIf

	Return _COMILETS(True)
EndFunc   ;==>_RUNTS

Func _COMILETS($delete)
	Local $curFile = _getSciteOpenFile()
	Local $isTS = StringRegExp($curFile, $re_fileExt)
	Local $compiledFile = Null


	;Reset resources
	$rBuffer = ""
	$AoIncluded = False
	_array_empty($aIncludedFiles)
	_array_empty($aNameSpaces)


	;If this is a valid file we will parse and run the created file in the same file (huh?)
	If $isTS Then
		$compiledFile = _ParseFile($curFile)
		If @error Then
			; This will also be used to yield logical errors..
			MsgBox(0, 0, "Error occured while parsing: " & $curFile & @CRLF & "Errorcode: " & @error)
			Return False
		EndIf
		; Run the compiled file
		ConsoleWrite(" # # # # TScript running: " & $curFile & " # # # # " & @CRLF)
		Local $timer = TimerInit()
		If $delete Then RunWait(@AutoItExe & ' "' & $compiledFile & '"', "", Default, $STDIN_CHILD)
		; Delete after RUN

		ConsoleWrite(" # # # # End: ~" & TimerDiff($timer) & " ms # # # # " & @CRLF)
		Sleep(150)
		If $delete Then FileDelete($compiledFile)
		Return $compiledFile
	Else ; Run file as usual without autoit Wrapper
		MsgBox(0, 0, StringFormat("Not a valid %s file", $ts_FileExt))
	EndIf
EndFunc   ;==>_COMILETS


; will convert ts to *.au3
Func _ParseFile($sFileName, $rFhandle = True)
	; Get current dir
	;Assign a new name for function  with string2hex so we remove weird stringnames
	$x_gFile = _StringToHex($sFileName)

	; Reset resources for file
	Local $aClassMembers[1] = [0] ; Alla "class members" for this file, reset at new file 2 save forestfires
	Local $x_cFile = 0
	Local $currentNameSpace = "", $rawNameSpace = ""

	If Not FileExists($sFileName) Then Return SetError(1, 0, 0)
	Local $sTargetFilename = StringRegExpReplace($sFileName, $re_fileExt, $ts_TargetExt)
	If $sTargetFilename == @ScriptName Then Return SetError(2, 0, 0)
	; Check if we need to include this file
	If fileIncluded($sFileName) Then Return SetError(3, 0, 0)
	; Prepare file
	Local $sBuffer = StringReplace(FileRead($sFileName), @CRLF, @LF)

	; Check if we going to include some files both ts. and .au3 files.
	Local $aTSInclude = StringRegExp($sBuffer, $re_tsInclude, 3)
	If IsArray($aTSInclude) Then
		Local $aTSIncludeLen = UBound($aTSInclude) - 1
		For $i = 0 To $aTSIncludeLen Step +2
			;Check if we only gonna add a regular .au3 file to the buffer
			If $aTSInclude[$i + 1] == ".au3" Then
				$rBuffer &= "#Include <" & $aTSInclude[$i] & ">" & @CRLF
				ContinueLoop ; Skip next step
			EndIf
			; Or add another .ts file
			Local $tsIncludeFile = StringFormat("%s.au3", $aTSInclude[$i]) ;add the target file as its full name ".ts.au3"
			;Parse next file
			Local $tsFinishedFile = _ParseFile(StringRegExpReplace($sFileName, "(.*\\)(.*)", "$1") & $tsIncludeFile, False) ;Parse next file but dont save the file as a new file
			If @error Then Return SetError(@error, 0, 0)
		Next
	EndIf

	Local $oFuncs = Null ; Destroy prev object
	$oFuncs = _AutoitObject_LinkedList()
	_ParseFuncRec($sBuffer, Null, $oFuncs)

	;This we are doing to stack everything in the file we are running
	If $rFhandle Then
		Local $fHandle = FileOpen($sTargetFilename, 2)
	EndIf

	;Just include this once.
	If Not $AoIncluded Then
		$rBuffer &= '#include "_Header_.au3"' & @CRLF
		$AoIncluded = True
	EndIf

	;Determine if current file has a namespace (Only affects GLOBAL SCOPE)
	;Determine if current file has a namespace (Only affects GLOBAL SCOPE)
	;Determine if current file has a namespace (Only affects GLOBAL SCOPE)
	;Determine if current file has a namespace (Only affects GLOBAL SCOPE)
	; IMPORTANT NAMESPACE ONLY TAKE FROM FILE BUFFER, NOT ON DA Global Return Buffer
	; IMPORTANT NAMESPACE ONLY TAKE FROM FILE BUFFER, NOT ON DA Global Return Buffer
	; IMPORTANT NAMESPACE ONLY TAKE FROM FILE BUFFER, NOT ON DA Global Return Buffer
	; IMPORTANT NAMESPACE ONLY TAKE FROM FILE BUFFER, NOT ON DA Global Return Buffer
	Local $nameSpaceInfo = StringRegExp($sBuffer, $re_NamespaceDetection, 3)
	Local $hasNameSpace = IsArray($nameSpaceInfo)

	If $hasNameSpace Then
		;Store the raw namespace globally, we are going to use it to match internally in functions
		$rawNameSpace = $nameSpaceInfo[0]
		$currentNameSpace = StringReplace($rawNameSpace, "/", "_") & "_" ; Add an ending _        "_"
		;Remove the var from buffer
		$sBuffer = StringRegExpReplace($sBuffer, $re_NamespaceDetection, "")
		; Add namespaces for later
		Local $NmSpaceData = [$rawNameSpace & "/", $currentNameSpace] ; add a / to this because we ad a _ to the current namespace
		_Array_Push($aNameSpaces, $NmSpaceData)
	EndIf

	Local $aNamespaceUsage[1] = [0]
	For $item In $oFuncs
		;Get parameters from extension or class info if needed
		Local $paramClassInfo = StringRegExp($item.params, $re_ClassDetection, 3)
		Local $paramExtensionInfo = StringRegExp($item.params, $re_ClassExtensionDetection, 3)
		;Determine if class or extension
		Local $isClass = IsArray($paramClassInfo)
		Local $isExtension = IsArray($paramExtensionInfo)

		; Adjust params for class and extension (They can never collide xD)
		If $isClass Or $isExtension Then
			;If we are gooing to use $this or the unkown $variable
			Local $finalParamsVar = ""

			;If class
			If $isClass Then
				$item.params = $paramClassInfo[0]
				$finalParamsTemplate = $this_varBaseName
			EndIf

			;If extension
			If $isExtension Then
				$item.params = $paramExtensionInfo[0]
				$finalParamsTemplate = $cls_varBaseName
			EndIf

			;Set params based on how they look only on SUB functions @ Classes, but Extensions can have this shit whenever
			If ($item.scope == $_SCOPE_LOCAL AND $isClass Or $isExtension) Then
				If isEmpty($item.params) Then
					$item.params = "$" & $finalParamsTemplate
				Else
					$item.params = StringFormat("$%s, %s", $finalParamsTemplate, $item.params)
				EndIf
			EndIf

			; Fix properties for classes and extensions
			Local $propertyTmplt = StringFormat("$%s.AddProperty('$2',$ELSCOPE_$1, $3)", $cls_varBaseName)
			$item.content = StringRegExpReplace($item.content, $re_ClassProperties, $propertyTmplt)
		EndIf


		; Check if we gonna create an "class", in that case we just glue that bastard right on there and fix some stuff heheheeh..
		If $isClass Then

			; Check for class extensions and replace them, this is exclusive to classes
			$item.content = StringRegExpReplace($item.content, $re_ClassExtensionExtender, "$$1($" & $cls_varBaseName & "$2)")

			; Only add $this if subclass, not for global
			Local $assignParentVar = $item.scope == $_SCOPE_LOCAL ? @TAB & StringFormat("$%s.AddProperty('__parent__',$ELSCOPE_READONLY, $%s)", $cls_varBaseName, $this_varBaseName) & @CRLF : ""

			;Add the AutoitObject class and the __parent__, __classname__ and __namespace__ variable
			$item.content = @TAB & StringFormat("Local $%s = _AutoItObject_Class()", $cls_varBaseName) & @CRLF & _
					@TAB & StringFormat("$%s.AddProperty('__className__', $ELSCOPE_READONLY, '%s')", $cls_varBaseName, $item.varNameClean) & @CRLF & _ ;Will add this name clean
					@TAB & StringFormat("$%s.AddProperty('__namespace__', $ELSCOPE_READONLY, '%s')", $cls_varBaseName, $rawNameSpace) & @CRLF & _ ;Will add this namespace as STRING
					$assignParentVar & _
					$item.content & @CRLF & _
					@TAB & StringFormat("Return $%s.Object", $cls_varBaseName)
		EndIf

		;Assign proper function names for non class (It always going to be the current function +1), we store all the replacements so we can fix the parameters...
		Local $y = $x_cFile + 1, $subFnc
		Do
			Local $cSubFnkName = $fnc_BaseName & $x_gFile & $y
			If $isClass Or $isExtension Then
				$subFnc = '$' & $cls_varBaseName & '.AddMethod("$2", "%s")'
				_Array_Push($aClassMembers, $cSubFnkName)
			Else
				$subFnc = "$1 %s$5"
			EndIf

			$item.content = StringRegExpReplace($item.content, $re_NestedFunctions, @TAB & StringFormat($subFnc, $cSubFnkName), 1)
			$y += 1
		Until @extended == 0

		; Last classmember is BOGUS, your DO loop replaces 1 extra time for shits and kicks apperently
		If $isClass And IsArray($aClassMembers) Then
			_Array_Remove($aClassMembers, $aClassMembers[0])
		EndIf

		; Create function
		Local $cFunkName = $fnc_BaseName & $x_gFile & $x_cFile

		; Check if this is file is a class member (And not self)
		; Store clean params for @MethodParams
		Local $item_params_clean = $item.params
		If memberOfClass($cFunkName, $aClassMembers) And Not $isClass And Not $isExtension Then
			If isEmpty($item.params) Then
				$item.params = "$" & $this_varBaseName
			Else
				$item.params = StringFormat("$%s, %s", $this_varBaseName, $item.params)
			EndIf
		EndIf

		; Look for @use x AS y in GLOBAL class scope (first scope only), bound to Classes
		Local $aLocalNamespaceUsage = Null
		If $item.scope == $_SCOPE_GLOBAL Then
			$aLocalNamespaceUsage = StringRegExp($item.content, $re_NamespaceUseInDetection, 3)
		EndIf

		If IsArray($aLocalNamespaceUsage) Then
			$item.content = StringRegExpReplace($item.content, $re_NamespaceUseInDetection, "") ; Remove it and keep the store array in $aLocalNamespaceUsage
			; Store usage
			For $p = 0 To UBound($aLocalNamespaceUsage) - 1
				_Array_Push($aNamespaceUsage, $aLocalNamespaceUsage[$p])
			Next
		EndIf

		;All macros are handled before we generate a function
		$item.content = StringRegExpReplace($item.content, $re_NamespaceMacro, '"'&$rawNameSpace&'"')
		$item.content = StringRegExpReplace($item.content, $re_MethodNameMacro, '"' & $item.varNameClean & '"')
		$item.content = StringRegExpReplace($item.content, $re_MethodParamsMacro, '"' & StringReplace($item_params_clean, '"',"'") & '"')

		;Fix dot conversion for $this. @ extensions which use $this in their content to the real (random) var
		If $isExtension Then
			$item.content = StringRegExpReplace($item.content, $re_ExtensionDotConvert, StringFormat("$%s.",$cls_varBaseName))
		EndIf

		$rBuffer &= StringFormat("Func %s(%s)", $cFunkName, $item.params) & @CRLF & _
				$item.content & @CRLF & _
				"EndFunc" & @CRLF & _
				($item.scope == $_SCOPE_GLOBAL ? StringFormat("Global Const $%s%s = %s%s", $currentNameSpace, $item.varNameClean, $cFunkName, $item.endFuncStuff) & @CRLF : "")
				;Increment for each function
		$x_cFile += 1

		; End of Function parse after-treatment
		; End of Function parse after-treatment
		; End of Function parse after-treatment

	;Check if we need to replace Aliases previously created with @Use x In y
	If $item.scope == $_SCOPE_GLOBAL Then
	If $aNamespaceUsage[0] > 0 Then
		For $w = 1 To $aNamespaceUsage[0] Step +2
			; We do this again because its for internal only, and should not be replaced global, then colission may occur.
			Local $lookFor = $aNamespaceUsage[$w + 1] & "/$" ; because we want to find the usage of the locally assigned namespace
			Local $replaceWith = "$" & StringReplace($aNamespaceUsage[$w], "/", "_") & "_" ; add a $
			; Replace
			$rBuffer = StringReplace($rBuffer, $lookFor, $replaceWith)
		Next
	EndIf
EndIf
	Next
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF
	; End of file, below this is after-treatment EOF


	If $rFhandle Then

		;Add the raw to the buffer data (if any)
		Local $rawData = StringRegExp($sBuffer, $re_Main, 3)

		If IsArray($rawData) Then
			$rBuffer = $rBuffer & @CRLF & $rawData[0]
		EndIf

		;Looks for namespaces to replace because we are at END OF FILE, here we LOOK AT $sBuffer not $rBuffer, becuz u want to include the after #MAIN part
		Local $_CurNamespace, $lookFor, $replaceWith
		For $w = 0 To $aNameSpaces[0]
			$_CurNamespace = $aNameSpaces[$w]
			If IsArray($_CurNamespace) Then
				$lookFor = $_CurNamespace[0]
				$replaceWith = $_CurNamespace[1]
				$rBuffer = StringReplace($rBuffer, $lookFor & "$", "$" & $replaceWith) ; remove the bogus $ at the end, and add a real $at the beginning
			EndIf
		Next

		FileWriteLine($fHandle, "#Region ~~~")
		FileWriteLine($fHandle, StringRegExpReplace($rBuffer, "\R+", @CRLF))
		FileWriteLine($fHandle, "#EndRegion ~~~")
		FileWriteLine($fHandle, $rawData)

		FileClose($fHandle)
	EndIf

	;Mark this file as used
	_Array_Push($aIncludedFiles, $sFileName)
	Return $sTargetFilename
EndFunc   ;==>_ParseFile

Func _ParseFuncRec($sBuffer, $inRecur, $oFuncs)

	Local $m = StringRegExp($sBuffer, $re_NestedFunctions, 4)
	If @error Then Return SetError(1, 0, 0) ; No more matches

	Local $m_len = UBound($m) - 1
	Local $scope = $inRecur ? $_SCOPE_LOCAL : $_SCOPE_GLOBAL

	For $i = 0 To $m_len
		Local $oFunc = _CObject($m[$i], $scope)

		$oFuncs.add($oFunc)
		_ParseFuncRec($oFunc.content, True, $oFuncs)
	Next
EndFunc   ;==>_ParseFuncRec

Func _CObject($m, $scope)
	Local $oRet = _AutoItObject_Create()
	_AutoItObject_AddProperty($oRet, "varName", $ELSCOPE_PUBLIC, $m[1]) ;
	_AutoItObject_AddProperty($oRet, "varNameClean", $ELSCOPE_PUBLIC, $m[2]) ; Only contains the name
	_AutoItObject_AddProperty($oRet, "params", $ELSCOPE_PUBLIC, $m[3])
	_AutoItObject_AddProperty($oRet, "content", $ELSCOPE_PUBLIC, $m[4])
	_AutoItObject_AddProperty($oRet, "endFuncStuff", $ELSCOPE_PUBLIC, $m[5]) ; Mby not needed herE?
	_AutoItObject_AddProperty($oRet, "scope", $ELSCOPE_PUBLIC, $scope)
	_AutoItObject_AddProperty($oRet, "memberOfClass", $ELSCOPE_PUBLIC, False) ; Noneeed
	Return $oRet
EndFunc   ;==>_CObject

; Check if we are a member of a class
Func memberOfClass($fncName, ByRef $aClassMembers)
	For $i = 1 To $aClassMembers[0]
		If $aClassMembers[$i] == $fncName Then Return True
	Next
	Return False
EndFunc   ;==>memberOfClass

;Check if is already included. generate a warning
Func fileIncluded($sFileName)
	For $i = 1 To $aIncludedFiles[0]
		If $aIncludedFiles[$i] == $sFileName Then Return True
	Next
	Return False
EndFunc   ;==>fileIncluded

Func _getSciteOpenFile()
	Return StringRegExpReplace(WinGetTitle($ScITEhwnd), $re_curFileDetection, "")
EndFunc   ;==>_getSciteOpenFile

Func rString($len)
	Local $ret = ""
	For $i = 1 To $len
		$ret &= "_" & Chr(Random(65, 90, 1))
	Next
	Return $ret
EndFunc   ;==>rString

Func isEmpty($str)
	Return StringRegExp($str, "^\s*$")
EndFunc   ;==>isEmpty
