#include-once

; This is all "wraithdu"

Func _AutoitObject_LinkedList()
	Local $oClassObj = _AutoItObject_Class()
	; Properties
	$oClassObj.AddProperty("first", $ELSCOPE_PUBLIC, 0)
	$oClassObj.AddProperty("last", $ELSCOPE_PUBLIC, 0)
	$oClassObj.AddProperty("size", $ELSCOPE_PUBLIC, 0)
    ; Methods
	$oClassObj.AddMethod("count", "_LinkedList_count")
	$oClassObj.AddMethod("add", "_LinkedList_add")
	$oClassObj.AddMethod("at", "_LinkedList_at")
	$oClassObj.AddMethod("remove", "_LinkedList_remove")
    ; Enum
	$oClassObj.AddEnum("_LinkedList_Enumnext", "_LinkedList_EnumReset")
    ; Return created object
	Return $oClassObj.Object
EndFunc   ;==>LinkedList

Func __Element__($data, $nextEl = 0)
	Local $oClassObj = _AutoItObject_Class()
	$oClassObj.AddProperty("next", $ELSCOPE_PUBLIC, 0)
	$oClassObj.AddProperty("data", $ELSCOPE_PUBLIC, 0)
	Local $oObj = $oClassObj.Object
	$oObj.next = $nextEl
	$oObj.data = $data
	Return $oObj
EndFunc   ;==>__Element__

Func _LinkedList_remove($this, $index)
	If $this.size = 0 Then Return SetError(1, 0, 0)
	Local $current = $this.first
	Local $previous = 0
	Local $i = 0
	Do
		If $i = $index Then
			If $this.size = 1 Then
				; very last element
				$this.first = 0
				$this.last = 0
			ElseIf $i = 0 Then
				; first element
				$this.first = $current.next
			Else
				If $i = $this.size - 1 Then $this.last = $previous ; last element
				$previous.next = $current.next
			EndIf
			$this.size = $this.size - 1
			Return
		EndIf
		$i += 1
		$previous = $current
		$current = $current.next
	Until $current = 0
	Return SetError(2, 0, 0)
EndFunc   ;==>_LinkedList_remove

Func _LinkedList_add($this, $newdata)
	Local $iSize = $this.size
	Local $oLast = $this.last
	If $iSize = 0 Then
		$this.first = __Element__($newdata)
		$this.last = $this.first
	Else
		$oLast.next = __Element__($newdata)
		$this.last = $oLast.next
	EndIf
	$this.size = $iSize + 1
EndFunc   ;==>_LinkedList_add

Func _LinkedList_at($this, $index)
	Local $i = 0
	For $Element In $this
		If $i = $index Then Return $Element
		$i += 1
	next
	Return SetError(1, 0, 0)
EndFunc   ;==>_LinkedList_at

Func _LinkedList_count($this)
	Return $this.size
EndFunc   ;==>_LinkedList_count

Func _LinkedList_EnumReset(ByRef $this, ByRef $iterator)
	#forceref $this
	$iterator = 0
EndFunc   ;==>_LinkedList_EnumReset

Func _LinkedList_Enumnext(ByRef $this, ByRef $iterator)
	If $this.size = 0 Then Return SetError(1, 0, 0)
	If Not IsObj($iterator) Then
		$iterator = $this.first
		Return $iterator.data
	EndIf
	If Not IsObj($iterator.next) Then Return SetError(1, 0, 0)
	$iterator = $iterator.next
	Return $iterator.data
EndFunc   ;==>_LinkedList_Enumnext
